/* coding: utf-8 */
/* Copyright (C) 2018 SofTek Systems, Inc. */

$(function() {

    init_paginator();
    enable_dropdown_balloon();

    // 入力用ダイアログを開く処理
  $('#modal-form').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var func = button.data('func');
	var category = parseInt(button.data('category'));
	var title = button.data('title');
	var userid = button.data('userid');
	if (typeof userid === 'undefined' || (userid == "")) {
	    userid = '0';
	}
	var name = button.data('name');
	var desc = button.data('desc');
	var users = button.data('users');

	var modal = $(this);
	modal.find('.modal-title .text-truncate').text(title);
	$('#form_userid').val(userid);
	$('#form_name').val(name);
	$('#form_desc').val(desc);
	if (func === "new") {
	    //$('#form_is_user').prop('checked', 'checked');
	    //$('#form_users_selected').val(JSON.stringify([]));
	    $('#form_func').val('new');
	    $('#form_submit').val('登録');
	    $('#form').attr('action', $('#url_new').val());
	} else {
	    $('#form_id').val(category);
	    //$('#form_is_user').prop('checked', parseInt(userid) > 0 ? 'checked' : '');
	    //$('#form_users_selected').val(JSON.stringify(users));
	    $('#form_func').val('mod');
	    $('#form_submit').val('更新');
	    $('#form').attr('action', $('#url_mod').val());
	}
  $('#modal-form').modal('show');

	//var temp_users = JSON.parse($('#temp_users').val());
	//var form_users_selected = JSON.parse($('#form_users_selected').val());

	//$('#selected_users > option').remove();
	//$('#unselected_users > option').remove();
	/*for (var i = 0; i < temp_users.length; i++) {
	    $($.inArray(temp_users[i]["id"], form_users_selected) != -1 ? '#selected_users' : '#unselected_users').append($('<option></option>', { value: temp_users[i]["id"], text: temp_users[i]["lastname"] + ' ' + temp_users[i]["firstname"]}));


	}*/
    });

    // 選択されたユーザを選択済に移動する。
    // 反映にはsubmitが必要。
    /*$('#select-user').on('click', function() {
	return move_selected_items('#form_users_selected',
				   '#unselected_users',
				   '#selected_users', false);
    });*/

    // 選択されたユーザを未選択に移動する。
    // 反映にはsubmitが必要。
    /*$('#unselect-user').on('click', function() {
	return move_selected_items('#form_users_selected',
				   '#selected_users',
				   '#unselected_users', true);
    });*/

    // submit処理
    // 簡易validation含む。完全なvalidationはModel or Controllerで。
    $('.form-submit').on('click', function() {
	var func = $('#form_func').val();
  var value = $('#form_name').val();
  if (value.length === 0) {
    alert('名称が入力されていません。');
    return false;
  }
  if( value[0].match(/\s/) || value[value.length - 1].match(/\s/) ){//カテゴリの先頭と末尾に空白を許可しない
    alert('カテゴリ名の先頭と末尾には、空白文字を使用できません。');
    $('#form_name').val(value.trim());
    return false;
  }
	var names = JSON.parse($('#category_names').val());
	if (func == 'new' && names) {
	    if ($.inArray($('#form_name').val(), names) >= 0) {
		alert('同一の名称のカテゴリが既に存在します。');
		return false;
	    }
	}
	if ($('#form_desc').val() == '') {
	    alert('概要が入力されていません。');
	    return false;
	}
	//return confirm('登録します。よろしいでしょうか？');
    });

  function toggle_category_related_info_content(target_content_id, target_icon_id){
    var target_content = $('#' + target_content_id);
    var target_icon = $('#' + target_icon_id);
    if( target_content.is(':visible') ){
        target_content.hide();
        target_icon.removeClass('fa-angle-up').addClass('fa-angle-down');
    }else{
        target_content.show();
        target_icon.removeClass('fa-angle-down').addClass('fa-angle-up');
    }
  }

  $('#toggle-related-host-info-content-btn').on('click', function(){
      toggle_category_related_info_content('related-host-info-content', 'related-host-info-btn-icon');
  });

  $('#toggle-related-user-info-content-btn').on('click', function(){
      toggle_category_related_info_content('related-user-info-content', 'related-user-info-btn-icon');
  });

  $('#toggle-related-rule-info-content-btn').on('click', function(){
      toggle_category_related_info_content('related-rule-info-content', 'related-rule-info-btn-icon');
  });

  function execute_delete_category(category_id, rule_info = '{}'){
      var path = $('#sidfm_categories_delete_path').val();
      $.ajax({
          type: 'POST',
          url: path,
          data: { 'id': category_id, 'rule_info': rule_info }
      }).done(function(result){
          if( result['err_message'].length > 0 ){
              alert(result['err_message']);
              location.reload();
          }else{
              $('#pages_form').attr('action', $('#sidfm_categories_path').val());
              update_view(result['host_ids'], result['html_ids']);
          }
      });
  }
  //カテゴリ削除時に、関連しているルールをチェック
  $('[data-delcategory]').on('click', function(){
      var button = $(this);
      var path = $('#sidfm_internal_api_check_related_rules_path').val();
      var del_category_id = button.attr('data-delcategory');
      //var submit_target = '[data-formdel="category_' + del_category_id + '"]';
      $('#submit-related-rules-item-form').attr({
          //'data-submit': submit_target,
          'data-name':  'formdel',
          'data-categoryid': del_category_id
      });
      //var form = $(submit_target);
      
      var is_related_hosts = false;
      var is_related_users = false;
      var is_related_rules = false;
      var conf_text = button.attr('data-conftext');
      var cat_name = button.data('categoryname');

      var check_rules = $.ajax({
        url: path,
        type: 'POST',
        data: {'page_name': 'category', 'delete_id': del_category_id},
      }).done(function(data){
          var rule_messages = data['rule_messages'];
          var rule_names = Object.keys(rule_messages);
          if(rule_names.length > 0){
            is_related_rules = true;
            $('#related-rule-info-area').show();
            delete data['rule_messages'];
            $('#submit-related-rules-item-form').attr('data-ruleinfo', JSON.stringify(data));
            $('#RuleInfoArea > *').remove();
            rule_names.sort();
            for(var i = 0; i < rule_names.length; i++){
                var rule_name = rule_names[i];
                var rule_message = rule_messages[rule_name];
                var item_name = rule_message['item_name'];
                var content = rule_message['content'];
                var reason = rule_message['reason'];
                var tr = $('<tr>').attr('class', 'list_alternative');
                var rule_name_td = $('<td>').attr('class', 'rule-name').text(rule_name);
                var item_td = $('<td>').attr('class', 'rule-item').text(item_name);
                var message_td = $('<td>').attr('class', 'rule-changes').text(content);
                var reason_td = $('<td>').attr('class', 'rule-reason').text(reason);
                tr.append(rule_name_td, item_td, message_td, reason_td);
                $('#RuleInfoArea').append(tr);
            }
          }else{
              $('#related-rule-info-area').hide();
          }
      });
      var check_hosts = $.ajax({
          url: $('#check_category_related_hosts_path').val(),
          type: 'POST',
          data: { 'category_id': del_category_id }
      }).done(function(hosts){
          if( hosts.length > 0 ){
              is_related_hosts = true;
              $('#related-host-info-area-tbody > *').remove();
              $('#related-host-info-area').show();
              var host_elms = hosts.map(function(host){
                  return $('<tr>').attr('class', 'list_alternative').append(
                      $('<td>').append(
                          $('<div>').attr({
                              'data-toggle': 'tooltip',
                              'data-title': ('ホスト名: ' + host.hostname + '<br/>表示名: ' + (host.ext_name ? host.ext_name : '(未設定)')),
                              'data-html': 'true',
                              'data-boundary': 'window',
                              'data-placement': 'left',
                          }).text(host.ext_name ? host.ext_name : host.hostname)
                      )
                  );
              });
              $('#related-host-info-area-tbody').append(host_elms);
              $('#related-host-info-area-tbody').find('[data-toggle="tooltip"]').tooltip();
          }else{
              $('#related-host-info-area').hide();
          }
      });

      var check_users = $.ajax({
          url: $('#check_category_related_users_path').val(),
          type: 'POST',
          data: { 'category_id': del_category_id }
      }).done(function(users){
          if( users.length > 0 ){
              is_related_users = true;
              $('#related-user-info-area').show();
              $('#related-user-info-area-tbody > *').remove();
              var user_elms = users.map(function(user){
                  return $('<tr>').attr('class', 'list_alternative').append(
                      $('<td>').append(
                          $('<div>').text(user.login)
                      ),
                      $('<td>').append(
                          $('<div>').text(user.lastname + ' ' + user.firstname)
                      )
                  );
              });
              $('#related-user-info-area-tbody').append(user_elms);
          }else{
              $('#related-user-info-area').hide();
          }      
      });

      $.when(check_rules, check_hosts, check_users).done(function(){
          if( is_related_rules || is_related_users || is_related_hosts){
              $('#related-host-info-content, #related-user-info-content, #related-rule-info-content').hide();
              $('#related-host-info-btn-icon, #related-user-info-btn-icon, #related-rule-info-btn-icon').removeClass('fa-angle-up')
                                                                                                        .addClass('fa-angle-down')
              var title_items = [];
              if( is_related_hosts ){
                  title_items.push('ホスト');
              }
              if( is_related_users ){
                  title_items.push('ユーザ');
              }
              if( is_related_rules ){
                  title_items.push('ルール');
              }
              $('#modalConfRelatedRules-title').text('「' + cat_name + '」' +  'に関連する' + title_items.join('/') + 'の情報');
              $('#modalConfRelatedRules').modal('show');
          }else{
              var conf = confirm(conf_text);
              if(!conf){
                  return false;
              }else{
                  execute_delete_category(del_category_id);
              }
          }
      });
   
  });
  
  //関連するルールを確認するmodalでOKボタンを押した時にformをsubmitする
  $('#submit-related-rules-item-form').on('click', function(){
        var button = $(this);
        var target = button.attr('data-submit');
        var name = button.attr('data-name');
        var ruleinfo = button.attr('data-ruleinfo');
        var category_id = button.attr('data-categoryid');
        execute_delete_category(category_id, ruleinfo);
        /*var form = $(target);
        form.append(
            $('<input>').attr({'type': 'hidden', 'name': name + '[rule_info]'}).val(ruleinfo)
        ).submit();*/
  });

  $('.balloon-dropdown').on('shown.bs.dropdown', function(){
        setTimeout(function(){ $('.balloon-card:visible').css({'white-space': 'normal', 'word-break': 'normal'}) }, 10);
  });
 
  //enterでformが送信されるのを防ぐ 
  $('.modal input').on('keydown', function(e) {
      if( (e.which && e.which === 13) || (e.keyCode && e.keyCode === 13) ){
          return false;
      } else {
          return true;
      }
  });
    activate_sidebar_item('sidebar-item-category-manip')
});


