/* coding: utf-8 */
/* Copyright (C) 2020 SofTek Systems, Inc. */

    //アプリケーション検索のsupport終了製品に関するメッセージの初期化・有効化 
    function toggle_support_end_products_statement(is_enable){
        if(is_enable){
            if($('#searched-prods-list').find('[data-supportend]').length > 0){
                $('#support-end-products-statement').removeClass('invisible').addClass('visible');
            }else{
                $('#support-end-products-statement').removeClass('visible').addClass('invisible');
            }
        }else{
            $('#support-end-products-statement').removeClass('visible').addClass('invisible');
        }
    }

    //ローカルプロダクトの表示の切り替え
    function toggle_searched_lproducts_area(is_enable){
        if(is_enable){
            if($('#searched-lprods-list').find('.lproduct-dropdown').length > 0){
                $('#searched-lprods-list').show();
                $('#local-product-statement').show();
            }else{
                $('#searched-lprods-list').hide();
                $('#local-product-statement').hide();
            }
        }else{
            $('#searched-lprods-list').hide();
            $('#local-product-statement').hide();
        }
    }

    /*function select_item_append(pid, name, vid, fullname, is_lproduct = '') {
        var selected_item = $('<a></a>', {
            class: 'btn btn-light-nb mb-1 mr-1' + (is_lproduct ? ' selected-lproduct' :  ''),
            href: '#',
            onclick: 'deselect_item(' + pid + ',' + vid + ",'" + is_lproduct + "')",
            text: fullname.length > 0 ? fullname : name,
            id: 'select_item_' + pid + '_' + vid + is_lproduct
        });
        var icon = $('<i></i>', { class: 'fas fa-minus-circle ml-1' });
        selected_item.append(icon);
        $('#selected-prods-list').append(selected_item);
    }*/
    
    var cnt_id_for_product_elm = 0;
    function select_item_append(pid, name, vid, fullname, is_lproduct = '') {
        var id = pid + '_' + vid + is_lproduct;
        var same_id_elm = $('#selected-prods-list').find('[data-editid="' + id + '"]');
        if(same_id_elm.length === 1){
            id += String(cnt_id_for_product_elm);
            cnt_id_for_product_elm += 1;
        }
        var wrap = $('<div></div>', {
            'data-editid': id,
            class: 'mr-1'
        });
        var btn = $('<div></div>', {
            class: 'btn-selected-product' + (is_lproduct ? ' selected-lproduct' :  ''),
        });
        var div = $('<div></div>', {
            class: 'd-flex'
        });
        var selected_item = $('<span></span>', {
            'data-selectedid': id,
            'data-vid': vid,
            text: fullname.length > 0 ? fullname : name,
            class: 'mr-auto'
        });
        var wrap_icons = $('<div></div>', {
            class: 'ml-auto'
        });
        var edit_icon = $('<i></i>', {
            class: 'fas fa-pen-square ml-3 edit-icon cursor-pointer',
            onclick: "edit_prod_version('" + id + "','" + pid + "','" + is_lproduct + "')",
            'data-iconid': id
        });
        var del_icon = $('<i></i>', {
            class: 'fas fa-minus-circle ml-1 toggle-minus-circle cursor-pointer',
            onclick: "deselect_item('" + id + "'," + pid + ",'" + is_lproduct + "')",
        });
        wrap_icons.append(edit_icon, del_icon);
        div.append(selected_item, wrap_icons);
        btn.append(div);
        wrap.append(btn);
        $('#selected-prods-list').append(wrap);
    }

    function select_item(pid, name, vid, fullname, is_lproduct = '') {
        if(is_lproduct.length > 0){
            var m_selected = JSON.parse($('#selected-lprods').val());
        }else{
            var m_selected = JSON.parse($('#selected-prods').val());
        }
        if (!m_selected[pid]) { m_selected[pid] = []; }
        for (var i = 0; i < m_selected[pid].length; i++) {
            if (m_selected[pid][i]['vid'] == vid) { return false; }
        }
        m_selected[pid].push({ pid: pid, name: name, vid: vid, fullname: fullname });
        if(is_lproduct.length > 0){
            $('#selected-lprods').val(JSON.stringify(m_selected));
        }else{
            $('#selected-prods').val(JSON.stringify(m_selected));
        }
        select_item_append(pid, name, vid, fullname, is_lproduct);
        return false;
    }

    function deselect_item(id, pid, is_lproduct = '') {
        if(is_lproduct.length > 0){
            var m_selected = JSON.parse($('#selected-lprods').val());
        }else{
            var m_selected = JSON.parse($('#selected-prods').val());
        }
        if (!m_selected[pid]) { return false; }
        var del_prod_name = $('#selected-prods-list').find('[data-selectedid="' + id + '"]');
        var vid = parseInt(del_prod_name.attr('data-vid'));
        m_selected[pid] = m_selected[pid].filter(function(v, i) {
            return vid != v['vid'];
        });
        if (m_selected[pid].length == 0) { delete m_selected[pid]; }
        if(is_lproduct.length > 0){
            $('#selected-lprods').val(JSON.stringify(m_selected));
        }else{
            $('#selected-prods').val(JSON.stringify(m_selected));
        }
        $('#selected-prods-list').find('[data-editid="' + id + '"]').remove();
        return false;
    }
    /*function deselect_item(pid, vid, is_lproduct = '') {
        $('#select_item_' + pid + '_' + vid + is_lproduct).remove();
        if(is_lproduct.length > 0){
            var m_selected = JSON.parse($('#selected-lprods').val());
        }else{
            var m_selected = JSON.parse($('#selected-prods').val());
        }
        if (!m_selected[pid]) { return false; }
            m_selected[pid] = m_selected[pid].filter(function(v, i) {
            return vid != v['vid'];
        });
        if (m_selected[pid].length == 0) { delete m_selected[pid]; }
        if(is_lproduct.length > 0){
            $('#selected-lprods').val(JSON.stringify(m_selected));
        }else{
            $('#selected-prods').val(JSON.stringify(m_selected));
        }
        return false;
    }*/

    //バージョンの編集
    function edit_prod_version(id, pid, is_lproduct = ''){
        var is_version_list = $('#edit-version-search-area[data-searchid="' + id + '"]').length === 1;
        $('#edit-version-search-area').remove();
        $('.modal:visible').find('.editing-icon').removeClass('editing-icon');
        if( !is_version_list ){
            $('[data-iconid="' + id + '"]').addClass('editing-icon');
            var search_area = $('<div></div>', {
                id: 'edit-version-search-area',
                class: 'edit-version-search-area',
                'data-searchid': id,
            });
            var label = $('<div></div>', {
                class: 'version-search-area-label d-flex'
            });
            label.append($('<div>').text('バージョン選択'));
            var version_list = $('<div></div>', {class: 'edit-version-searched-list scrollable-menu-150 border-top border-bottom mr-1 ml-1'});
            var path = $('#sidfm_internal_api_get_product_versions_path').val();
            is_lproduct = is_lproduct.length > 0;
            if( is_lproduct ){
                var data = {'lproduct_id': pid};
            }else{
                var data = {'product_id': pid};
            }
            $.post(path, data, function(prod_info){
                var elms = [];
                var prod = prod_info['product'];
                var lprod = prod_info['lproduct'];
                if(prod){
                    var is_support_end_prod = false;
                    var name = prod['name'];
                    var versions = prod_info['versions'];
                    var on_click = "exec_edit_prod_version('" + 
                                   id + "','" + pid + "'," + "'0','" + sanitize_string(name) + "')";
                    var is_prod_support_end = prod['is_support_end'];
                    if( is_prod_support_end ){
                        is_support_end_prod = true;
                    }
                    elms.push(
                        $('<div></div>', {
                            class: 'searched-version-item' + (is_prod_support_end ? ' text-danger' : ''),
                            onclick: on_click,
                            text: '全て'
                        })
                    );
                    versions.forEach(function(v){
                        if(!v['vid']){
                            v['vid'] = 0;
                        }
                        var on_click = "exec_edit_prod_version('" +
                                       id + "','" + pid + "','" + v['vid'] + "','" + sanitize_string(name) + "','" + sanitize_string(v['fullname']) + "')";
                        var is_version_support_end = v['is_support_end'];
                        if( is_version_support_end ){
                            is_support_end_prod = true;
                        }
                        elms.push(
                            $('<div></div>', {
                                class: 'searched-version-item' + (is_version_support_end ? ' text-danger' : ''),
                                onclick: on_click,
                                text: v['fullname']
                            })
                        );
                    });
                    if( is_support_end_prod ){
                        label.append(
                            $('<div>').attr('class', 'ml-auto mr-2').append(
                                $('<span>').attr('class', 'font-size-small').text('※注意事項'),
                                $('<span>').append(
                                    $('<a>').attr({
                                        'class': 'ml-1',
                                        'data-toggle': 'tooltip',
                                        'data-html': 'true',
                                        'data-title': '赤い文字で表記されているバージョンは、SIDfmでのサポートが終了しています。<br>SIDfmでのサポートが終了しているバージョンについては、脆弱性が公開されてもSIDfmコンテンツが作成されずSIDfm VMでも脆弱性が検出されません。',
                                        'data-boundary': 'window'
                                    }).append($('<i>').attr('class', 'fas fa-question-circle c_gray_70'))
                                )
                            )
                        );
                    }
                }else if(lprod){
                    label.append(
                        $('<div>').attr('class', 'ml-auto mr-2').append(
                            $('<span>').attr('class', 'font-size-small').text('※注意事項'),
                            $('<span>').append(
                                $('<a>').attr({
                                    'class': 'ml-1',
                                    'data-toggle': 'tooltip',
                                    'data-title': 'ローカルプロダクトについては、脆弱性が公開されてもSIDfmコンテンツが作成されずSIDfm VMでも脆弱性が検出されません。',
                                    'data-boundary': 'window'
                                }).append($('<i>').attr('class', 'fas fa-question-circle c_gray_70'))
                            )
                        )
                    );
                    var name = lprod['name'];
                    var lversions = prod_info['lversions'];
                    var on_click = "exec_edit_prod_version('" +
                                   id + "','" + pid + "'," + "'0','" + sanitize_string(name) + "',''," + "'true'" + ")";
                    elms.push(
                        $('<div></div>', {
                            class: 'searched-version-item',
                            onclick: on_click,
                            text: '全て'
                        })
                    );
                    lversions.forEach(function(v){
                        var on_click = "exec_edit_prod_version('" + 
                                       id + "','" + pid + "','" + v['id'] + "','" + sanitize_string(name) + "','" + sanitize_string(v['fullname']) + "'," + "'true'" + ")";
                        elms.push(
                            $('<div></div>', {
                                class: 'searched-version-item',
                                onclick: on_click,
                                text: v['fullname']
                            })
                        );
                    });
                }
                version_list.append(elms);
                search_area.append(label, version_list);
                $('body').append(search_area.hide());
                search_area.find('[data-toggle="tooltip"]').tooltip();
                set_version_list_placement();
                search_area.show();
            });
        }
    }

    //バージョンの編集の実行
    function exec_edit_prod_version(id, pid, vid, name, fullname = '', is_lproduct = ''){
        vid = parseInt(vid);
        var target_prod_name = $('#selected-prods-list').find('[data-selectedid="' + id + '"]');
        var prev_vid = parseInt(target_prod_name.attr('data-vid'));

        is_lproduct = is_lproduct.length > 0;
        var selected_prods = (is_lproduct ? $('#selected-lprods') : $('#selected-prods'));
        var prods_data = JSON.parse(selected_prods.val());
        var target_data = prods_data[pid];
        var filtered_data = [];
        var is_existing_ver = false;
        for(var i = 0; i < target_data.length; i++){
            var d = target_data[i];
            var d_vid = parseInt(d['vid']);
            if(d_vid == vid){
                is_existing_ver = true;
                break;
            }
            if(d_vid != prev_vid){
                filtered_data.push(d);
            }
        }
        if(is_existing_ver){
            alert('既に登録済みのプロダクトです');
            return false;
        }
        filtered_data.push({
            pid: parseInt(pid),
            vid: vid,
            name: name,
            fullname: fullname,
        });
        prods_data[pid] = filtered_data;
        selected_prods.val(JSON.stringify(prods_data));
        target_prod_name.attr('data-vid', vid);
        target_prod_name.text(fullname.length > 0 ? fullname : name);
        $('#edit-version-search-area').remove();
        $('.modal:visible').find('.editing-icon').removeClass('editing-icon');
    }

    //バージョン一覧の位置調整
    function set_version_list_placement(){
        var elm = $('#edit-version-search-area');
        if( elm.length > 0 ){
            var id = elm.attr('data-searchid');
            var target_elm = $('.modal:visible').find('[data-editid="' + id + '"]');
            var offset = target_elm.offset();
            elm.offset({'left': offset.left, 'top': offset.top + target_elm.outerHeight() + $(window).scrollTop()});
        }
    }

$(function(){
    init_paginator();
    init_sidfm();
    enable_dropdown_balloon();
    sticky_control('SummaryTable', 'local_vuls');
    activate_sidebar_item('sidebar-item-local-vuls-manip');
    set_style_for_ActionArea_on_filter_dropdown_event();

    $(window).on('load', function() {
        setTimeout(function(){
            set_scroll();
            $(window).on('resize scroll', set_scroll);
        },200);
    });

    //ソート
    $('.sort-vuls-name').on('click', sort_toggle('vuls-name'));
    $('.sort-vuls-flg-enable').on('click', sort_toggle('vuls-flg-enable'));
    $('.sort-vuls-last-update-time').on('click', sort_toggle('vuls-last-update-time'));    

    //サマリーテーブルの検索
    function submit_search_item(search_item, keyword){
        if(keyword.length > 0){
            reset_pages_checked_values();
            var filters = JSON.parse($('#pages_filters').val());
            filters[search_item] = String(keyword);
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
        }
    }

    function reset_search_item(search_item){
        reset_pages_checked_values();
        var filters = JSON.parse($('#pages_filters').val());
        filters[search_item] = '';
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
    }
    
    $('.search_form').on('submit', function(){
        var id = $(this).attr('data-formid');
        var input = $(this).find($('[data-inputfor="' + id + '"]'));
        var value = input.val();
        submit_search_item('search_' + id, value);
        return false;
    });

    $('.reset_search_item').on('click', function(){
        var id = $(this).attr('data-resetid');
        reset_search_item('search_' + id);
        return false;
    });

    $('.filter_item_link').on('click', function(e){
        e.preventDefault();
        reset_pages_checked_values();
        var keyword = $(this).attr('data-value');
        var item_name = $(this).attr('data-linkid');
        var filters = JSON.parse($('#pages_filters').val());
        filters['search_' + item_name] = String(keyword);
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
    });

    $('#filter-clear').on('click', function() {
        reset_pages_checked_values();
        $('#pages_filters').val('{}')
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    });

    //サマリー表のプロダクト検索
    $('#filters-search-product-btn').on('click', function(){
       var button = $(this);
       var prod_name = button.attr('data-productname');
       $('#seared-product-name').val(prod_name);
       if( prod_name.length === 0 ){
           $('#seared-product-name').attr('disabled', true);
       }else{
           $('#seared-product-name').attr('readonly', true)
                                    .addClass('bg-white');
       }
       /*if( $('#filter-product-list > * ').length === 0 ){
           $('#filter-product-notice').removeClass('visible').addClass('invisible');
       }else{
           $('#filter-product-notice').removeClass('invisible').addClass('visible');
       }*/
       $('#FilterProductModal').modal('show');
    });

    var jqxhr = null
    $('#filter-product-input').on('input', function(){
        $('[data-toggle="tooltip"]').tooltip('hide');
        if(jqxhr){
            jqxhr.abort();
        }
        var keyword = $(this).val();
        var path = $('#sidfm_licenses_api_substr_search_path').val();
        $('#filter-product-list > *').remove();
        jqxhr = $.get(path, { 'params[keyword]': keyword }, function(data) {
            if(keyword.length < 2){
                //$('#filter-product-notice').removeClass('visible').addClass('invisible');
                if(keyword.length != 0){
                    $('#filter-product-input-tooltip').attr('data-original-title', '2文字以上入力して下さい').tooltip('show');
                }else{
                    $('#filter-product-input-tooltip').tooltip('hide');
                }
            }else{
                $('#filter-product-input-tooltip').tooltip('hide');
                var lproducts = data['lproducts'];
                delete data['lproducts'];
                var pids = Object.keys(data);
                if(pids.length === 0 && lproducts.length === 0){
                    //$('#filter-product-notice').removeClass('visible').addClass('invisible');
                    $('#filter-product-input-tooltip').attr('data-original-title', '該当するプロダクトはありません').tooltip('show');
                }else{
                    //$('#filter-product-notice').removeClass('invisible').addClass('visible');
                    for (var i = 0; i < pids.length; i++) {
                        var product = data[pids[i]]['product'];
                        var p_item = $('<span></span>', {
                            class: 'dropdown'
                        });
                        p_item.append($('<button></button>', {
                            class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                            type: 'button',
                            'data-toggle': 'dropdown',
                            'aria-haspopup': 'true',
                            'aria-expanded': 'false',
                            text: product['name']
                        }));
                        var p_menu = $('<div></div>', {
                            class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                        });
                        p_menu.append($('<a></a>', {
                            class: 'dropdown-item exec-search-product-btn',
                            text: '全て',
                            href: '#',
                            'data-pid': pids[i]
                        }));
                        var versions = data[pids[i]]['versions'];
                        if (versions) {
                            for (var j = 0; j < versions.length; j++) {
                                var version = versions[j];
                                var p_ver = $('<a></a>', {
                                    class: 'dropdown-item exec-search-product-btn',
                                    href: '#',
                                    text: version['fullname'],
                                    'data-vid': version['vid']
                                });
                                p_menu.append(p_ver);
                            }
                        }
                        p_item.append(p_menu);
                        $('#filter-product-list').append(p_item);
                    }
                    for (var i = 0; i < lproducts.length; i++) {
                         var lproduct_data = lproducts[i];
                         var lproduct = lproduct_data['product'];
                         var lversions = lproduct_data['versions'];
                         var p_item = $('<span></span>', {
                             class: 'dropdown lproduct-dropdown'
                         });
                         p_item.append($('<button></button>', {
                             class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                             type: 'button',
                             'data-toggle': 'dropdown',
                             'aria-haspopup': 'true',
                             'aria-expanded': 'false',
                             text: lproduct['name']
                         }));
                         var p_menu = $('<div></div>', {
                             class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                                    'aria-labelledby': 'm_searched_item_' + lproduct['id']
                         });
                         p_menu.append($('<a></a>', {
                             class: 'dropdown-item exec-search-product-btn',
                             text: '全て',
                             href: '#',
                             'data-lpid': lproduct['id']
                         }));
                         if (lversions.length > 0) {
                             for (var j = 0; j < lversions.length; j++) {
                                 var lversion = lversions[j];
                                 var p_ver = $('<a></a>', {
                                     class: 'dropdown-item exec-search-product-btn',
                                     href: '#',
                                     text: lversion['fullname'],
                                     'data-lvid': lversion['id']
                                 });
                                 p_menu.append(p_ver);
                             }
                         }
                         p_item.append(p_menu);
                         $('#filter-product-list').append(p_item);
                     }
                }
            }
        });
    });
 
    $(document).on('click', '.exec-search-product-btn', function(e){
        e.stopPropagation();
        var button = $(this);
        var pid = button.attr('data-pid');
        var vid = button.attr('data-vid');
        var lpid = button.attr('data-lpid');
        var lvid = button.attr('data-lvid');
        var filter = JSON.parse($('#pages_filters').val());
        if( pid ){
            var prod_info = {'pid': pid};
        }else if( vid ){
            var prod_info = {'vid': vid};
        }else if( lpid ){
            var prod_info = {'lpid': lpid};
        }else if( lvid ){
            var prod_info = {'lvid': lvid};
        }else{
            var prod_info = {};
        }
        reset_pages_checked_values();
        filter['product'] = prod_info;
        $('#pages_filters').val(JSON.stringify(filter));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
    }); 

    //プロダクト検索リセット
    $('#reset-filters-product').on('click', function(){
        reset_pages_checked_values();
        var filter = JSON.parse($('#pages_filters').val());
        filter['product'] = {};
        $('#pages_filters').val(JSON.stringify(filter));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
    });
 
    //ロード時のサマリー表のチェックボックス
    if ($('#pages_all_checked').val() === 'false'){ $('#allSelect').prop('checked', false);}

    var pages_checked = JSON.parse($('#pages_checked').val());
    var all_vul_ids = JSON.parse($('#all-vul-ids').val());
    if(pages_checked.length === all_vul_ids.length && all_vul_ids.length > 0){
        $('#allSelect').prop('checked', true);
    }else{
        $('#allSelect').prop('checked', false);
    }

    //一括ボタンの活性・非活性
    if(pages_checked.length === 0){
        $('.bulk-btn').prop('disabled', true);
    }else{
        $('.bulk-btn').prop('disabled', false);
    }

    //pages_checkの値とチェックされているものの整合性を取る
    $(window).on('pageshow', function(){
        var is_all_checked = $('#pages_all_checked').val();
        if(is_all_checked === 'true'){
            var all_ids = JSON.parse($('#all-vul-ids').val());
            $('#VulsTable').find('#allSelect, .SelectVul').prop('checked', true);
            $('#pages_checked').val(JSON.stringify(all_ids));
        }else{
            $('#VulsTable').find('#allSelect, .SelectVul').prop('checked', false);
            var pages_checked = JSON.parse($('#pages_checked').val());
            var target_elm = '';
            pages_checked.forEach(function(id){
                target_elm += '.SelectVul[value="' + id + '"],';
            });
            target_elm = target_elm.slice(0, -1);
            $(target_elm).prop('checked', true);
        }
    });
 
    //サマリー表のチェックボックスの選択・非選択
    $('#allSelect').on('change', function(){
        var chk_box = $(this);
        if(chk_box.prop('checked')){
            $('.SelectVul').prop('checked', true);
            $('#pages_checked').val($('#all-vul-ids').val());
            $('#pages_all_checked').val('true');
            $('.bulk-btn').prop('disabled', false);
        }else{
            $('.SelectVul').prop('checked', false);
            $('#pages_checked').val('[]');
            $('#pages_all_checked').val('false');
            $('.bulk-btn').prop('disabled', true);
        }
    });

    $('.SelectVul').on('change', function(){
        var chk_box = $(this);
        var vul_id = parseInt(chk_box.val());
        var selected_ids = JSON.parse($('#pages_checked').val());
        var all_vul_ids = JSON.parse($('#all-vul-ids').val());
        if(chk_box.prop('checked')){
            selected_ids.push(vul_id);
        }else{
            var idx = selected_ids.indexOf(vul_id);
            selected_ids.splice(idx, 1);
        }
        $('#pages_checked').val(JSON.stringify(selected_ids));
        if(all_vul_ids.length === selected_ids.length){
            $('#allSelect').prop('checked', true);
            $('#pages_all_checked').val('true');
        }else{
            $('#allSelect').prop('checked', false);
            $('#pages_all_checked').val('false');
        }
        if(selected_ids.length === 0){
            $('.bulk-btn').prop('disabled', true);
        }else{
            $('.bulk-btn').prop('disabled', false);
        }
    });

    //画面risize時にバージョン一覧の位置調整
    $(window).on('resize', function(){
        set_version_list_placement();
    });

    //プロダクト検索modalで、スクロール時に検索バージョンの一覧の表示位置修正
    $('.modal').on('scroll', function(){
        var product_modal = $('.product-modal:visible');
        if(product_modal.length > 0){
            set_version_list_placement();
        }
    });

    //プロダクト検索画面で、画面クリックでバージョン一覧消去
    $('.product-modal').on('click', function(e){
        var e = e.target
        if(e){
            e = $(e);
            if(e.attr('id') != 'edit-version-search-area' && e.closest('#edit-version-search-area').length == 0 && !e.hasClass('edit-icon')){
                $('#edit-version-search-area').remove();
                $(this).find('.editing-icon').removeClass('editing-icon');
            }
        }
    });
 
    //登録時のナビゲーション
    //function create_navi_elm(){
    //    var navi = $('<div>').attr('id', 'register-navi');
    //    var navi_items = [
    //        $('<span>').attr('class', 'vul-navi-item').append($('<a>').attr({/*'href': '1', */'class': 'vul-navi-link'}).text('基本情報')),
    //        $('<span>').attr('class', 'vul-navi-item').append($('<a>').attr({/*'href': '2', */'class': 'vul-navi-link'}).text('影響製品')),
    //        $('<span>').attr('class', 'vul-navi-item').append($('<a>').attr({/*'href': '3', */'class': 'vul-navi-link'}).text('付属情報')),
    //        $('<span>').attr('class', 'vul-navi-item').append($('<a>').attr({/*'href': '4', */'class': 'vul-navi-link'}).text('CVSS情報')),
    //        $('<span>').attr('class', 'vul-navi-item').append($('<a>').attr({/*'href': '5', */'class': 'vul-navi-link'}).text('SRI情報'))
    //    ];
    //    navi.append(navi_items);
    //    $('body').append(navi.hide());
    //    navi.offset({'left': ($(window).width() / 2) - (navi.outerWidth() / 2)}).show();
    //}

    //modal切り替え時にvalidate
    function validate_vul_modal(modal_id){
        var err = false;
        var msg = '';
        if(modal_id === 'CreateVulModal'){
            var vul_name = $('#temp-vul-title-field').val();
            if( vul_name.length === 0 ){
                err = true;
                msg = '脆弱性名の入力は必須です。';
            } 
        }else if(modal_id === 'RegistProductsModal'){
            
        }else if(modal_id === 'RegistVulInfoModal'){
           
        }else if(modal_id === 'RegistCvssModal'){
            var cvss_score = $('#temp-vul-cvss-score').val();
            var cve_ids = JSON.parse($('#temp-vul-cve-ids-data').val());
            if( cve_ids.length > 0 ){ 
                var temp_cvss_data = JSON.parse($('#temp-cvss-data').val());
                for( cvss_item in temp_cvss_data ){
                    if(!temp_cvss_data[cvss_item]){ 
                        err = true;
                        msg = 'CVE IDを登録する場合は、CVSS指標の各項目の選択は必須です。';
                        break;
                    }
                }
                if(!err){
                    if(cvss_score.length === 0){
                        err = true;
                        msg = 'CVE IDを登録する場合は、CVSSスコアの入力は必須です。';
                    }
                }
            }else{
                if( cvss_score.length > 0 ){
                    err = true;
                    msg = 'CVSSスコアを登録する場合は、CVE IDの登録が必要です。';
                }
                var temp_cvss_data = JSON.parse($('#temp-cvss-data').val());
                var is_cvss_selected = false
                for(cvss_item in temp_cvss_data){
                    if(temp_cvss_data[cvss_item]){
                        is_cvss_selected = true;
                        break;
                    }
                }
                if( is_cvss_selected && !err ){
                    alert('CVE IDを登録しない場合、CVSS指標を選択していてもCVSS指標は無効となりますのでご注意下さい。');
                }
            }
            if(cvss_score.length > 0 && !cvss_score.match(/^[0-9]{1,2}\.{0,1}[0-9]{0,1}$/) /*|| *cvss_score.match(/\.$/)*/){
                err = true;
                msg = 'CVSSスコアは0.0以上の数で、少数点以下は第一位のみ入力可能です。';
            }else if(cvss_score.length > 0 && cvss_score > 10){
                err = true;
                msg = 'CVSSスコアは10.0が最大値です。';
            }
        }else if(modal_id === 'RegistSriModal'){
            
        }
        return {'is_err': err, 'message': msg};
    }

    //modalの切り替え
    $('.next-modal-btn, .back-to-conf-modal').on('click', function(){
        var modal_id = $(this).closest('.modal').attr('id');
        var validation = validate_vul_modal(modal_id);
        var is_err = validation['is_err'];
        if( is_err ){
            alert(validation['message']);
            return false;
        }else{
            var self_modal = $(this).closest('.modal');
            var self_modal_content = $(this).closest('.modal-content');
            var next_modal = $($(this).attr('data-target'));
            self_modal.modal('hide'); 
            next_modal.modal('show');
        }
    });

    $('.back-modal-btn').on('click', function(){
        var self_modal = $(this).closest('.modal');
        var target_modal = $($(this).attr('data-target'));
        self_modal.modal('hide');
        target_modal.modal('show');
    });

    //validation
    $('#temp-vul-title-field').on('input', function(){
        if($(this).val().length === 0){
            $('#CreateVulModal .next-modal-btn').prop('disabled', true);
        }else{
            $('#CreateVulModal .next-modal-btn').prop('disabled', false);
        }
    });

    //リンクを入力
    function set_insert_link(link){
        var link_data = JSON.parse($('#input-link-data').val());
        link_data['link'] = link;
        $('#input-link-data').val(JSON.stringify(link_data));
    }

    function set_insert_link_name(link_name){
        var link_data = JSON.parse($('#input-link-data').val());
        link_data['link_name'] = link_name;
        $('#input-link-data').val(JSON.stringify(link_data));
    }
    
    var insert_link_target_elm;
    $('.related-create-vul-modal input[data-input!="false"], .related-create-vul-modal textarea').on('click', function(){
        /*if(insert_link_target_elm){
            insert_link_target_elm.removeClass('selecting-field');
        }
        $(this).addClass('selecting-field');*/
        if(insert_link_target_elm && insert_link_target_elm.attr('id') != $(this).attr('id')){
            $('.input-link-name, .input-link').val('');
        }
        insert_link_target_elm = $(this);
        if(insert_link_target_elm.attr('data-input') === 'unusable'){
            $('.modal:visible').find('.insert-link-btn').prop('disabled', true);
        }else{
            $('.modal:visible').find('.insert-link-btn').prop('disabled', false);
        }
    });
 
    $('.input-link').on('input', function(){
        set_insert_link($(this).val());
    });

    $('.input-link-name').on('input', function(){
        set_insert_link_name($(this).val());
    });

    $('[data-dropdownfor="keyword"]').on('shown.bs.dropdown', function(){
        var link = $('.input-link:visible').val();
        var link_name = $('.input-link-name:visible').val();
        set_insert_link(link);
        set_insert_link_name(link_name);
    });

    $('.exec-input-link').on('click', function(){
        if(!insert_link_target_elm || insert_link_target_elm.is(':hidden')){
            alert('リンクを入力する箇所が選択されていません。入力する箇所を押下後、再度操作して下さい');
            return false;
        }
        if(insert_link_target_elm.attr('id') === 'temp-vul-title-field'){
            alert(form_item_names['vul_name'] + 'にリンクは使用できません。');
            return false;
        }else if(insert_link_target_elm.attr('id') === 'temp-vul-short-description-field'){
            alert(form_item_names['short_description'] + 'にリンクは使用できません。');
            return false;
        }
        if(insert_link_target_elm.is(':visible')){
            var link_data = JSON.parse($('#input-link-data').val());
            var link = link_data['link'];
            var link_name = (link_data['link_name'].trim().length > 0 ? link_data['link_name'] : link);
            if(link.match(/<|>|"|\|&/) || link_name.match(/<|>|"|\|&/)){
                alert('リンク名とリンクに、<>"\&の文字は使用できません');
                return false;
            }
            if(link.length === 0){
                alert('リンクを入力して下さい');
                return false;
            }
            try{
                var url = new URL(link);
            }catch(e){
                alert('リンクに誤りがあります');
                return false;
            }
            if(!link.match(/^http|^https|^ftp/)){
                alert('プロトコルは、http/https/ftpのいずれかのみ使用可能です');
                return false;
            }
            var insert_word = '%LINK:' + link_name + '$$$' + link + '%';
            var pos = insert_link_target_elm.get(0).selectionStart;  
            var len = insert_link_target_elm.val().length;
            var content = insert_link_target_elm.val();
            var before = content.substr(0, pos);
            var after = content.substr(pos);
            content = before + insert_word + after;
            insert_link_target_elm.val(content);
            $('.input-link-name, .input-link').val('');
        }
        if(insert_link_target_elm.attr('id') === 'temp-vul-title-field'){
            //脆弱性名が入力されたら「次へ」ボタンを活性にする
            $('#CreateVulModal .next-modal-btn').prop('disabled', false);
        }
    });

    //modalの切り替えで「リンクを入力」をリセット
    $('.modal').on('show.bs.modal', function(){
        insert_link_target_elm = null;
        $('.input-link-name, .input-link').val('');
        $('.modal:visible').find('.insert-link-btn').prop('disabled', false);
    });

    //id="temp-cvss-data"の初期値
    function get_default_temp_cvss_data(){
        var temp_cvss_data = {
            'AV': null,
            'AC': null,
            'PR': null,
            'UI': null,
            'S': null,
            'C': null,
            'I': null,
            'A': null
        }
        return temp_cvss_data;
    }

    //新規登録
    //初期化
    function reset_create_modals(){
        //全登録画面
        $('.edit-vul-name').val('').hide();
        //登録画面1
        $('#temp-vul-title-field, #temp-vul-short-description-field, #temp-vul-description-field').val('');
        $('#temp-select-area').val('0');
        $('#temp-select-riskid').val('1');
        $('#CreateVulModal .next-modal-btn').prop('disabled', true);
        $('#temp-vul-flg-enable').val('enable');
        $('.back-to-conf-modal, #cancel-edit').hide();
        $('#cancel-register').show();
        $('.input-link, .input-link-name').val('');
        insert_link_target_elm = null;
        //登録画面2
        $('#selected-prods, #selected-lprods').val('{}');
        toggle_support_end_products_statement(false);
        toggle_searched_lproducts_area(false);
        $('#selected-prods-list > *').remove();
        $('#searched-lprods-list > *').remove();
        $('#searched-prods-list > *').remove();
        $('#vul-search-prods').val('');
        //登録画面3
        $('#temp-vul-confirmation-field, #temp-vul-workaround-field, #temp-vul-related-info-field').val('');
        //登録画面4
        $('#temp-vul-cvss-score').val('');
        $('#select-temp-vul-exploitable').val('true');
        $('#select-temp-cvss-item-area [data-cvss]').removeClass('selected-cvss-item').addClass('unselected-cvss-item');
        $('#temp-vul-cve-ids > * ').remove();
        $('#temp-vul-cve-ids').append(
            $('<div>').attr({
                'id': 'no-cve-ids-message',
                'class': 'cve-id-item'
            }).text('未登録')
        );
        $('#input-vul-cve-id').val('CVE-');
        $('#temp-vul-cve-ids-data').val('[]');
        $('#temp-cvss-data').val(JSON.stringify(get_default_temp_cvss_data()));
        $('#RegistCvssModal .next-modal-btn').prop('disabled', true);
        //登録画面5
        $('#select-temp-s-category-area select').val('1');
        $('#temp-vul-sri-memo').val('');
        //登録確認画面
        $('#vul-title-field').val('');
        $('#select-area').val('0');
        $('#select-riskid').val('1');
        $('#vul-short-description-field, #vul-description-field').val('');
        $('#vul-flg-enable').val('enable');
        $('#vul-affected-products > * ').remove();
        $('#vul-affected-prods-data, #vul-affected-lprods-data').val('{}');
        $('#vul-confirmation-field, #vul-workaround-field, #vul-related-info-field').val('');
        $('#vul-cvss-score').val('');
        $('#vul-cve-ids > * ').remove();
        $('#vul-cve-ids-data').val('[]');
        $('#select-vul-exploitable').val('true');
        $('#conf-selected-cvss-item-area [data-cvss]').removeClass('selected-cvss-item').addClass('unselected-cvss-item');
        $('#vul-cvss-data').val('{}');
        $('#vul-s-category-sri').val('{}');
        $('#conf-select-s-category-area [data-scat]').val('1');
        $('#vul-sri-memo').val('');
        $('#exec-create-vul').text('登録').removeAttr('data-modify');
        $('#form-create-vul').attr('action', $('#create_path').val());
        $('#vul-cvss-score, #vul-cve-ids, #select-vul-exploitable, #conf-selected-cvss-item-area').removeClass('invalid-item');
        $('#conf-selected-cvss-item-area').find('.cvss-item-name, .cvss-item').removeClass('invalid-item');
        $('#vul-comments-area').hide();
        $('#vul-comments > *').remove();
        $('#vul-comments-data').val('{}');
        //更新履歴画面
        $('#vul-update-comment-field').val('');
    }

    $('#create-new-local-vul').on('click', function(){
        reset_create_modals();
        $('.vul-modal-title-label').text('新規登録');
        $('#CreateVulModal').modal('show');
    });

    function toggle_RegistCvssModal_next_btn(){
        var cve_ids = JSON.parse($('#temp-vul-cve-ids-data').val());
        if( cve_ids.length > 0 ){
            temp_cvss_data = JSON.parse($('#temp-cvss-data').val());
            var is_all_selected = true;
            for( cvss_item in temp_cvss_data ){
                if(!temp_cvss_data[cvss_item]){
                    is_all_selected = false;
                    break;
                }
            }
            if( is_all_selected && $('#temp-vul-cvss-score').val().length > 0){
                $('#RegistCvssModal .next-modal-btn').prop('disabled', false);
            }else{
                $('#RegistCvssModal .next-modal-btn').prop('disabled', true);
            }
        }else{
            $('#RegistCvssModal .next-modal-btn').prop('disabled', false);
        }
    }

    //CVSSスコアの入力時にvalidation
    $('#temp-vul-cvss-score').on('input', function(){
        toggle_RegistCvssModal_next_btn();
    });

    //CVSS指標の選択
    $('#select-temp-cvss-item-area [data-cvss]').on('click', function(){
        var button = $(this);
        var temp_cvss_data = JSON.parse($('#temp-cvss-data').val());
        var cvss = button.attr('data-cvss');
        var cvss_val = button.attr('data-value');
        if(button.hasClass('selected-cvss-item')){
            button.removeClass('selected-cvss-item').addClass('unselected-cvss-item');
            temp_cvss_data[cvss] = null;
        }else{
            $('#select-temp-cvss-item-area').find('[data-cvss="' + cvss + '"][class*=selected-cvss-item]')
                                            .removeClass('selected-cvss-item')
                                            .addClass('unselected-cvss-item');
            button.removeClass('unselected-cvss-item').addClass('selected-cvss-item');
            temp_cvss_data[cvss] = cvss_val;
        }
        $('#temp-cvss-data').val(JSON.stringify(temp_cvss_data));
        toggle_RegistCvssModal_next_btn();
    });

    //CVE ID/CVSS情報のmodal
    $('#RegistCvssModal').on('show.bs.modal',function(){
        toggle_RegistCvssModal_next_btn();
    });

    //ローカルプロダクト検索
    var jqxhr = null
    $('#vul-search-prods').on('input', function(){
        $('[data-toggle="tooltip"]').tooltip('hide');
        if(jqxhr){
            jqxhr.abort();
        }
        var keyword = $(this).val();
        var path = $('#sidfm_licenses_api_substr_search_path').val();
        jqxhr = $.get(path, { 'params[keyword]': keyword }, function(data) {
            if(keyword.length < 2){
                $('#searched-prods-list > *').remove();
                $('#searched-lproducts-list > *').remove();
                toggle_support_end_products_statement(false);
                toggle_searched_lproducts_area(false);
                if(keyword.length != 0){
                    $('#search-prods-tooltip').attr('data-original-title', '2文字以上入力して下さい').tooltip('show');
                }else{
                    $('#search-prods-tooltip').tooltip('hide');
                }
            }else{
                var lproducts = data['lproducts'];
                delete data['lproducts'];
                var pids = Object.keys(data);
                if(pids.length === 0 && lproducts.length === 0){
                    $('#search-prods-tooltip').attr('data-original-title', '該当するプロダクトはありません').tooltip('show');
                    toggle_support_end_products_statement(false);
                    toggle_searched_lproducts_area(false);
                }else{
                    $('#search-prods-tooltip').tooltip('hide');
                    pids.sort(function(a, b){
                        var a_is_support_end = data[a]['product']['is_support_end'] ? -1 : 1;
                        var b_is_support_end = data[b]['product']['is_support_end'] ? -1 : 1;
                        if(a_is_support_end > b_is_support_end){
                            return -1;
                        }else{
                            return 1;
                        }
                    });
                }
                $('#searched-prods-list > *').remove();
                $('#searched-lprods-list > *').remove();
                for (var i = 0; i < pids.length; i++) {
                    var product = data[pids[i]]['product'];
                    var p_item = $('<span></span>', {
                        class: 'dropdown'
                    });
                    if(product['is_support_end']){
                        p_item.attr({
                            'data-supportend': 'true',
                        }).append(
                            $('<button>').attr({
                                'class': 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                                'type': 'button',
                                'data-toggle': 'dropdown',
                                'aria-haspopup': 'true',
                                'aria-expanded': 'false',
                            }).html('<span>&times;</span><span class="text-danger">' + product['name'] + '</span>')
                        );
                    }else{
                        p_item.append($('<button></button>', {
                            class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                            type: 'button',
                            'data-toggle': 'dropdown',
                            'aria-haspopup': 'true',
                            'aria-expanded': 'false',
                            text: product['name']
                        }));
                    }
                    var p_menu = $('<div></div>', {
                        class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                               'aria-labelledby': 'm_searched_item_' + pids[i]
                    });
                    var p_onclick = 'select_item(' + pids[i] + ',\'' + sanitize_string(product['name']) + '\',0,\'\')';
                    p_menu.append($('<a></a>', {
                        class: 'dropdown-item',
                        text: '全て',
                        href: '#',
                        onclick: p_onclick
                    }));
                    var versions = data[pids[i]]['versions'];
                    if (versions) {
                        versions.sort(function(a, b){
                            var a_is_support_end = a['is_support_end'] ? -1 : 1;
                            var b_is_support_end = b['is_support_end'] ? -1 : 1;
                            if(a_is_support_end > b_is_support_end){
                                return -1;
                            }else{
                                return 1;
                            }
                        });
                        for (var j = 0; j < versions.length; j++) {
                            var version = versions[j];
                            p_onclick = 'select_item(' +
                                pids[i] +
                                ',\'' +
                                sanitize_string(product['name']) + '\',' +
                                version['vid'] + ',\'' +
                                sanitize_string(version['fullname']) + '\',\'\')';
                            var p_ver = $('<a></a>', {
                                class: 'dropdown-item',
                                href: '#',
                                onclick: p_onclick
                            });
                            if(version['is_support_end']){
                                p_ver.attr({
                                    'data-supportend': 'true',
                                }).html('<span>&times;</span><span class="text-danger">' + version['fullname'] + '</span>');
                            }else{
                                p_ver.text(version['fullname']);
                            }
                            p_menu.append(p_ver);
                        }
                    }
                    p_item.append(p_menu);
                    $('#searched-prods-list').append(p_item);
                }
                for (var i = 0; i < lproducts.length; i++) {
                    var lproduct_data = lproducts[i];
                    var lproduct = lproduct_data['product'];
                    var lversions = lproduct_data['versions'];
                    var p_item = $('<span></span>', {
                        class: 'dropdown lproduct-dropdown'
                    });
                    p_item.append($('<button></button>', {
                        class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle text-primary',
                        type: 'button',
                        'data-toggle': 'dropdown',
                        'aria-haspopup': 'true',
                        'aria-expanded': 'false',
                        text: lproduct['name']
                    }));
                    var p_menu = $('<div></div>', {
                        class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                               'aria-labelledby': 'm_searched_item_' + lproduct['id']
                    });
                    var p_onclick =
                        'select_item(' +
                        lproduct['id'] +
                        ',\'' +
                        sanitize_string(lproduct['name']) +
                        '\',0,\'\'' + ' ,\'true\')';
                    p_menu.append($('<a></a>', {
                         class: 'dropdown-item text-primary',
                         text: '全て',
                         href: '#',
                         onclick: p_onclick
                    }));
                    if (lversions.length > 0) {
                         for (var j = 0; j < lversions.length; j++) {
                             var lversion = lversions[j];
                             p_onclick = 'select_item(' +
                                lproduct['id'] +
                                ',\'' +
                                sanitize_string(lproduct['name']) + '\',' +
                                lversion['id'] + ',\'' +
                                sanitize_string(lversion['fullname']) +
                                '\'' + ', \'true\')';
                             var p_ver = $('<a></a>', {
                                 class: 'dropdown-item text-primary',
                                 href: '#',
                                 onclick: p_onclick
                             }).text(lversion['fullname']);
                             p_menu.append(p_ver);
                         }
                     }
                     p_item.append(p_menu);
                     $('#searched-lprods-list').append(p_item);
                 }
                 toggle_support_end_products_statement(true);
                 toggle_searched_lproducts_area(true);
             }
        });
    });

    //CVE IDの頭文字固定
    $('#input-vul-cve-id').on('input', function(){
        var cve_id = $(this).val();
        if(cve_id.substr(0, 4) != 'CVE-'){
            if(cve_id.substr(0, 3) === 'CVE'){
                $(this).val('CVE-' + cve_id.substr(3));
            }else{
                $(this).val('CVE-');
            }
        }
    });

    //CVE ID追加
    $('#add-cve-id').on('click', function(){
        var cve_id = $('#input-vul-cve-id').val();
        if(!cve_id.match(/^CVE\-[0-9]{4}\-[0-9]+$/)){
            alert('フォーマットが正しくありません。');
            return false;
        }else{
            var cve_ids = JSON.parse($('#temp-vul-cve-ids-data').val());
            var is_same_cve_id = false;
            for(var i = 0; i < cve_ids.length; i++){
                var t_cve_id = cve_ids[i];
                if(t_cve_id === cve_id){
                    alert('既に登録済みのCVE IDです。');
                    is_same_cve_id = true;
                    break;
                }
            } 
            if(is_same_cve_id){return false;}
            $('#no-cve-ids-message').remove();
            var cve_id_elm = $('<div>').attr({
                'class': 'cve-id-item d-flex justify-content-between',
                'data-cveitem': cve_id
            }).append(
                $('<div>').attr('class', 'g-line-height-2').text(cve_id),
                $('<button>').attr({
                    'class': 'delete-cve-id btn btn-sm delete-cve-id-btn',
                    'data-cveid': cve_id
                }).text('削除')
            );
            $('#temp-vul-cve-ids').append(cve_id_elm);
            cve_ids.push(cve_id);
            $('#temp-vul-cve-ids-data').val(JSON.stringify(cve_ids));
            $('#input-vul-cve-id').val('CVE-');
        }
        toggle_RegistCvssModal_next_btn();
    });

    //CVE ID削除
    $(document).on('click', '.delete-cve-id', function(){
        var cve_id = $(this).attr('data-cveid');
        var cve_ids = JSON.parse($('#temp-vul-cve-ids-data').val());
        $(this).closest('[data-cveitem]').remove();
        cve_ids = cve_ids.filter(function(existing_cve_id){
            return cve_id != existing_cve_id;
        });
        if(cve_ids.length === 0){
            $('#temp-vul-cve-ids').append(
                $('<div>').attr({
                    'id': 'no-cve-ids-message',
                    'class': 'cve-id-item'
                }).text('未登録')
            );
        }
        $('#temp-vul-cve-ids-data').val(JSON.stringify(cve_ids));
        toggle_RegistCvssModal_next_btn();
    });

    //登録確認modal
    $('#ConfVulModal').on('show.bs.modal', function(){
        $('#vul-title-field').val($('#temp-vul-title-field').val());
        $('#select-area').val($('#temp-select-area').val());
        $('#select-riskid').val($('#temp-select-riskid').val());
        $('#vul-short-description-field').val($('#temp-vul-short-description-field').val());
        $('#vul-flg-enable').val($('#temp-vul-flg-enable').val());
        $('#vul-description-field').val($('#temp-vul-description-field').val());
        $('#vul-confirmation-field').val($('#temp-vul-confirmation-field').val());
        $('#vul-workaround-field').val($('#temp-vul-workaround-field').val());
        $('#vul-related-info-field').val($('#temp-vul-related-info-field').val());
        $('#vul-cvss-score').val($('#temp-vul-cvss-score').val());
        $('#select-vul-exploitable').val($('#select-temp-vul-exploitable').val());
        $('#vul-sri-memo').val($('#temp-vul-sri-memo').val());
       
        //影響を受ける製品
        $('#vul-affected-products > * ').remove(); 
        var selected_prods = JSON.parse($('#selected-prods').val());
        var selected_lprods = JSON.parse($('#selected-lprods').val());
        $('#vul-affected-prods-data').val(JSON.stringify(selected_prods));
        $('#vul-affected-lprods-data').val(JSON.stringify(selected_lprods));
        if (Object.keys(selected_prods).length === 0 && Object.keys(selected_lprods).length === 0) {
            $('#vul-affected-products').append($('<div>').attr('class', 'conf-prod-item').text('未登録'));
        }else{
            var selected_prod_elms = []; 
            for (prod_id in selected_prods){
                var prods = selected_prods[prod_id];
                prods.forEach(function(prod){
                    var name = (prod.fullname.length > 0 ? prod.fullname : prod.name);
                    selected_prod_elms.push($('<div>').attr('class', 'conf-prod-item').text(name));
                }); 
            }
            for (lprod_id in selected_lprods) {
                var lprods = selected_lprods[lprod_id];
                lprods.forEach(function(lprod){
                    var name = (lprod.fullname.length > 0 ? lprod.fullname : lprod.name);
                    selected_prod_elms.push($('<div>').attr('class', 'conf-prod-item').text(name));
                });
            }
            selected_prod_elms.sort(function(a, b){
                if(a.text().toLowerCase() > b.text().toLowerCase()){
                    return 1;
                }else{
                    return -1;
                }
            });
            $('#vul-affected-products').append(selected_prod_elms); 
        }
    
        //CVE ID
        $('#vul-cve-ids-data').val($('#temp-vul-cve-ids-data').val());
        var cve_ids = JSON.parse($('#temp-vul-cve-ids-data').val());
        $('#vul-cve-ids > * ').remove();
        if(cve_ids.length > 0){
            cve_ids.sort();
            cve_ids = cve_ids.map(function(cve_id){
                return $('<div>').attr('class', 'conf-cve-id-item').text(cve_id);    
            });
            $('#vul-cve-ids').append(cve_ids);
            $('#vul-cvss-score, #vul-cve-ids, #select-vul-exploitable, #conf-selected-cvss-item-area').removeClass('invalid-item');
            $('#conf-selected-cvss-item-area').find('.cvss-item-name, .cvss-item').removeClass('invalid-item');
        }else{
            $('#vul-cve-ids').append($('<div>').attr('class', 'conf-cve-id-item').text('未登録'));
            $('#vul-cvss-score, #vul-cve-ids, #select-vul-exploitable, #conf-selected-cvss-item-area').addClass('invalid-item');
            $('#conf-selected-cvss-item-area').find('.cvss-item-name, .cvss-item').addClass('invalid-item');
        }

        //CVSS指標
        $('#vul-cvss-data').val($('#temp-cvss-data').val());
        var cve_ids = JSON.parse($('#temp-vul-cve-ids-data').val());
        var conf_cvss_area = $('#conf-selected-cvss-item-area');
        conf_cvss_area.find('[data-cvss]').removeClass('selected-cvss-item')
                                          .addClass('unselected-cvss-item')
        if( cve_ids.length > 0 ){
            var temp_cvss_data = JSON.parse($('#temp-cvss-data').val());
            for ( label in temp_cvss_data ){
                var cvss_val = temp_cvss_data[label];
                conf_cvss_area.find('[data-cvss="' + label + '"][data-value="' + cvss_val + '"]')
                              .addClass('selected-cvss-item')
                              .removeClass('unselected-cvss-item');
            }
        }else{
            $('#vul-cvss-data').val('{}');
        }
        //システムカテゴリ別のリスク影響度
        var s_category_sri_data = JSON.parse($('#vul-s-category-sri').val());
        var select_sri_area = $('#conf-select-s-category-area');
        $('#select-temp-s-category-area').find('[data-scat]').each(function(){
            var risk_id = $(this).val();
            var s_cat_id = $(this).attr('data-scat');
            select_sri_area.find('[data-scat="' + s_cat_id + '"]').val(risk_id);
            s_category_sri_data[s_cat_id] = risk_id;
        });
        $('#vul-s-category-sri').val(JSON.stringify(s_category_sri_data));

    });

    $('#ConfVulModal').on('hide.bs.modal', function(){
        $(this).find('.modal-body').scrollTop(0);
        $('#vul-affected-products, #vul-cve-ids').scrollTop(0);
    });

    //登録確認画面で編集ボタンを押した時、編集対象のmodalに切り替える
    $('.edit-vul-items').on('click', function(){
        var target_modal = $(this).attr('data-edit');
        $('#ConfVulModal').modal('hide');
        $(target_modal).modal('show');
    });

    //編集実行時に表示するpopup 更新履歴を残すかどうか確認
    /*function create_conf_popup_for_comment(){
        $('body').append($('<div>').attr('id', 'conf-popup-back'));
        var popup = $('<div>').attr('id', 'conf-popup');
        var msg = $('<div>').attr('class', 'm-5').text('更新履歴を登録しますか?');
        var btn_area = $('<div>').attr({'class': 'd-flex ml-5 mr-2 mb-2'});
        var btns = $('<div>').attr({'class': 'ml-auto'}).append(
            $('<button>').attr({
                'type': 'button',
                'id': 'btn-to-comment-modal',
                'class': 'btn btn-primary btn-sm mr-1'
            }).text('はい'),
            $('<button>').attr({
                'type': 'button',
                'id': 'submit-edit-form',
                'class': 'btn btn-secondary btn-sm',
            }).text('いいえ')
        );
        btn_area.append(btns);
        popup.append(msg, btn_area);
        $('body').append(popup);
    }*/

    /*$(document).on('click', '#btn-to-comment-modal', function(){
        $('#conf-popup-back, #conf-popup').remove();
        $('#CommentModal').modal('show');
    });

    $(document).on('click', '#submit-edit-form', function(){
        $('#form-create-vul').submit();
    })*/

    //登録実行
    const form_item_names = JSON.parse($('#form_item_names').val());//項目名一覧
    $('#exec-create-vul').on('click', function(){
        var button = $(this);
        //入力されたリンクに誤りが無いかチェック
        var path = $('#check_texts_path').val();
        //var vul_name = $('#vul-title-field').val();
        //var s_description = $('#vul-short-description-field').val();
        var description = $('#vul-description-field').val();
        var affect_conf_text = $('#vul-confirmation-field').val();
        var workaround = $('#vul-workaround-field').val();
        var related_info = $('#vul-related-info-field').val();
        //var comment = $('#vul-update-comment-field').val();
        //var sri_memo = $('#vul-sri-memo').val();
        var vul_name_label = form_item_names['vul_name'];
        var s_description_label = form_item_names['short_description'];
        var description_label = form_item_names['description'];
        var affect_conf_text_label = form_item_names['conf'];
        var workaround_label = form_item_names['workaround'];
        var related_info_label = form_item_names['related_info'];
        //var comment_label = form_item_names['comment'];
        var sri_memo_label = form_item_names['sri_memo'];
        var texts_data = [
           // {'text': vul_name, 'label': vul_name_label},
           // {'text': s_description, 'label': s_description_label},
            {'text': description, 'label': description_label},
            {'text': affect_conf_text, 'label': affect_conf_text_label},
            {'text': workaround, 'label': workaround_label},
            {'text': related_info, 'label': related_info_label},
           // {'text': comment, 'label': comment_label},
           // {'text': sri_memo, 'label': sri_memo_label}
        ];
        $.ajax({
            type: 'POST',
            url: path,
            data: {'texts_data': JSON.stringify(texts_data)},
        }).done(function(err_messages){
            if(err_messages.length > 0 ){
                msg = err_messages.join('\n')
                alert(msg);
                return false; 
            }else{
                if(button.attr('data-modify')){//編集の時に更新履歴を必ず残す
                    //create_conf_popup_for_comment();
                    $('#CommentModal').modal('show');
                }else{ 
                    $('#form-create-vul').submit();
                }
            }
        });
    });

    //編集
    function set_vul_edit_data(parameter){
        //リンク入力初期化
        $('.next-modal-btn').prop('disabled', false);
        $('.input-link, .input-link-name').val('');
        insert_link_target_elm = null;
      
        //編集実行後、サマリー表の状態を保持するためのparams
        $('#pages-offset-for-modify').val($('#pages_offset').val());
        $('#pages-perpage-for-modify').val($('#pages_per_page').val());
        $('#pages-order-for-modify').val($('#pages_order').val());
        $('#pages-filters-for-modify').val($('#pages_filters').val());
       
        var vul_id = parameter['id'];
        var vul_name = parameter['vul_name'];
        var area_id = parameter['area_id'];
        var risk_id = parameter['risk_id'];
        var s_description = parameter['short_description'];
        var description = parameter['description'];
        var flg_enable = (parameter['flg_enable'] ? 'enable' : 'disable');
        var products = parameter['products'];
        var lproducts = parameter['lproducts'];
        var conf_text = parameter['conf'];
        var workaround = parameter['workaround'];
        var related_info = parameter['related_info'];
        var comments = parameter['comments'];
        var cvss_score = parameter['cvss_score'];
        var flg_exploitable = parameter['flg_exploitable'];
        var cve_ids = parameter['cve_ids'];
        var cvss_idxes = parameter['cvss_idxes'];
        var s_cats_sri = parameter['s_cats_sri'];
        var sri_memo = parameter['sri_memo'];
       
        //データ・要素を編集用にセット(初期化)する
        //全登録画面
        $('.edit-vul-name').text(vul_name).show();

        //登録画面1
        $('#temp-vul-title-field').val(vul_name);
        $('#temp-vul-short-description-field').val(s_description);
        $('#temp-vul-description-field').val(description);
        $('#temp-select-area').val(area_id);
        $('#temp-select-riskid').val(risk_id);
        $('#temp-vul-flg-enable').val(flg_enable);
        $('.back-to-conf-modal, #cancel-edit').show();
        $('#cancel-register').hide();
        //登録画面2
        $('#selected-prods-list > *').remove();
        $('#searched-lprods-list > *').remove();
        $('#searched-prods-list > *').remove();
        $('#vul-search-prods').val('');
        $('#selected-prods, #selected-lprods').val('{}');
        toggle_support_end_products_statement(false);
        toggle_searched_lproducts_area(false);
        for( pid in products ){
            var prods = products[pid];
            prods.forEach(function(prod){
                select_item(pid, prod.name, prod.vid, prod.fullname)
            });
        }
        for( pid in lproducts ){
            var prods = lproducts[pid];
            prods.forEach(function(prod){
                select_item(pid, prod.name, prod.vid, prod.fullname, 'true')
            });
        }
        //登録画面3
        $('#temp-vul-confirmation-field').val(conf_text);
        $('#temp-vul-workaround-field').val(workaround);
        $('#temp-vul-related-info-field').val(related_info);
        //登録画面4 + 登録確認画面
        $('#temp-vul-cvss-score').val(cvss_score === null ? '' : cvss_score);
        $('#select-temp-vul-exploitable').val(flg_exploitable);
        $('#vul-cvss-data').val(JSON.stringify(cvss_idxes));
        if( Object.keys(cvss_idxes).length > 0 ){
            $('#temp-cvss-data').val(JSON.stringify(cvss_idxes));
        }else{
            $('#temp-cvss-data').val(JSON.stringify(get_default_temp_cvss_data()));
        }
        var cvss_item_area = $('#select-temp-cvss-item-area, #conf-selected-cvss-item-area');
        cvss_item_area.find('[data-cvss]').removeClass('selected-cvss-item').addClass('unselected-cvss-item');
        $('#vul-cvss-score, #vul-cve-ids, #select-vul-exploitable, #conf-selected-cvss-item-area').removeClass('invalid-item');
        $('#conf-selected-cvss-item-area').find('.cvss-item-name, .cvss-item').removeClass('invalid-item');
        if(cve_ids.length > 0){
            for(cvss_item in cvss_idxes){
                var value = cvss_idxes[cvss_item];
                cvss_item_area.find('[data-cvss="' + cvss_item + '"][data-value="' + value + '"]')
                              .removeClass('unselected-cvss-item').addClass('selected-cvss-item');
            }
        }else{
            $('#vul-cvss-score, #vul-cve-ids, #select-vul-exploitable, #conf-selected-cvss-item-area').addClass('invalid-item');
            $('#conf-selected-cvss-item-area').find('.cvss-item-name, .cvss-item').addClass('invalid-item');
        }
        
        $('#vul-cve-ids-data, #temp-vul-cve-ids-data').val(JSON.stringify(cve_ids));
        $('#temp-vul-cve-ids > *').remove();
        $('#vul-cve-ids > * ').remove();
        if(cve_ids.length > 0){
            cve_ids.sort();
            cve_id_elms_for_temp_elm = [];
            cve_id_elms = [];
            cve_ids.forEach(function(cve_id){
                var elm = $('<div>').attr('class', 'conf-cve-id-item').text(cve_id);
                cve_id_elms.push(elm);
                var elm = $('<div>').attr({
                    'class': 'cve-id-item d-flex justify-content-between',
                    'data-cveitem': cve_id
                }).append(
                    $('<span>').attr('class', 'g-line-height-2').text(cve_id),
                    $('<button>').attr({
                        'class': 'delete-cve-id btn btn-sm delete-cve-id-btn',
                        'data-cveid': cve_id
                    }).text('削除')
                );
                cve_id_elms_for_temp_elm.push(elm);
            });
            $('#temp-vul-cve-ids').append(cve_id_elms_for_temp_elm);
            $('#vul-cve-ids').append(cve_id_elms);
        }else{
            $('#temp-vul-cve-ids').append(
                $('<div>').attr({
                    'id': 'no-cve-ids-message',
                    'class': 'cve-id-item'
                }).text('未登録')
            );
            $('#vul-cve-ids').append($('<div>').attr('class', 'conf-cve-id-item').text('未登録'));
        }
        $('#input-vul-cve-id').val('CVE-');
        //登録画面5 + 登録確認画面
        var s_category_area = $('#select-temp-s-category-area, #conf-select-s-category-area');
        for(cat_id in s_cats_sri){
            var value = s_cats_sri[cat_id];
            s_category_area.find('[data-scat="' + cat_id + '"]').val(value);
        }
        $('#temp-vul-sri-memo').val(sri_memo);
        //登録確認画面
        $('#vul-title-field').val(vul_name);
        $('#select-area').val(area_id);
        $('#select-riskid').val(risk_id);
        $('#vul-short-description-field').val(s_description);
        $('#vul-flg-enable').val(flg_enable);
        $('#vul-description-field').val(description);
        $('#vul-confirmation-field').val(conf_text);
        $('#vul-workaround-field').val(workaround);
        $('#vul-related-info-field').val(related_info);
        $('#vul-cvss-score').val(cvss_score);
        $('#select-vul-exploitable').val(flg_exploitable);
        $('#vul-sri-memo').val(sri_memo);
        $('#form-create-vul').attr('action', $('#modify_path').val());
        $('#vul-id-for-modify').val(vul_id);
        $('#vul-comments-data').val(JSON.stringify(comments));
        $('#vul-comments > *').remove();
        if(comments.length > 0){
            comment_elms = comments.map(function(cmt){
                return $('<li>').attr({
                    'class': 'vul-comment-item', 
                    'data-id': cmt['id'],
                }).text('・ ' + cmt['mes']);
            });
            $('#vul-comments').append(comment_elms);
            $('#vul-comments-area').show();
        }else{
            $('#vul-comments-area').hide();
        }
        //更新履歴画面
        $('#vul-update-comment-field').val('');
    }
    
    $('.edit-vul').on('click', function(){
        var button = $(this);
        var param = button.data('param');
        set_vul_edit_data(param);
        $('.vul-modal-title-label').text('編集');
        $('#exec-create-vul').text('変更').attr({
            'data-modify': 'true',
        });
        $('#ConfVulModal').modal('show');
    });

    //登録確認画面でキャンセルボタンを押した時はキャンセルの確認をする。
    //クリックミスで編集内容が消えてしまわないようにするため。
    $('#cancel-edit').on('click', function(){
        var conf = confirm('編集した内容は破棄されます。よろしいですか?');
        if(conf){
            $('#ConfVulModal').modal('hide');
        }
    });
   
    //更新履歴modal
    $('#CommentModal').on('show.bs.modal', function(){
        $('body').append($('<div>').attr('id', 'CommentModal-back'));
    });
   
    $('#CommentModal').on('hide.bs.modal', function(){
        $('#CommentModal-back').remove();
    });

    //更新履歴を登録して変更実行
    $('#execute-modify-with-comment').on('click', function(){
        var comment = $('#vul-update-comment-field').val();
        if( comment.length === 0 ){
            alert('１文字以上入力して下さい');
            return false;
        }else if( comment.trim().length === 0 ){
            alert('空白文字のみの更新履歴は登録できません');
            return false;
        }

        //var vul_data = JSON.parse($('[data-vuleditid ="' + $('#vul-id-for-modify').val() + '"]').attr('data-param'));
        var path = $('#sidfm_local_vuls_get_issue_related_vul_ids_path').val();
        $.post(path, {'vul_ids': JSON.stringify([ $('#vul-id-for-modify').val() ])}, function(issue_related_vul_ids){
            if( issue_related_vul_ids.includes(parseInt($('#vul-id-for-modify').val())) && $('#vul-flg-enable').val() === 'enable' ){
                var conf = confirm('このローカル脆弱性に関連する脆弱性チケットがあります。変更すると、次のホストの脆弱性同期時に、その脆弱性チケットの対応状況(ステータス)が変更される可能性があります。よろしいですか?');
                if( !conf ){
                    return false;
                }
            }/*else if(String(vul_data['flg_enable']) === 'true' && $('#vul-flg-enable').val() === 'disable'){
                var conf = confirm('このローカル脆弱性に関連する脆弱性チケットがある場合、次のホストの脆弱性同時期に、それらの脆弱性チケットの対応状況(ステータス)が「影響無」になります。よろしいですか?');
                if( !conf ){
                    return false;
                }
            }*/
            //リンク入力がある場合、リンク入力に誤りが無いかチェック
            var path = $('#check_texts_path').val();
            var comment_label = form_item_names['comment'];
            var texts_data = [ {'text': comment, 'label': comment_label} ];
            $.ajax({
                type: 'POST',
                url: path,
                data: {'texts_data': JSON.stringify(texts_data)},
            }).done(function(err_messages){
                if(err_messages.length > 0 ){
                    msg = err_messages.join('\n')
                    alert(msg);
                    return false;
                }else{
                    var comments = JSON.parse($('#vul-comments-data').val());
                    var new_comment = {'id': 0, 'mes': comment};
                    comments.push(new_comment);
                    $('#vul-comments-data').val(JSON.stringify(comments))
                    $('#form-create-vul').submit();
                }
            });
        });
    });
   
    function toggle_edit_comment_btn(button){
        if(button.attr('data-editing')){
            //編集完了時
            button.removeClass('finish-edit-comment btn-primary')
                  .addClass('btn-edit')
                  .removeAttr('data-editing')
                  .text('編集');
        }else{
            button.removeClass('btn-edit')
                  .addClass('btn-primary finish-edit-comment')
                  .attr('data-editing', 'true')
                  .text('完了');
        } 
    }

    function toggle_cancel_edit_comment_btn(button){
        if(button.prop('disabled')){
            button.prop('disabled', false);
        }else{
            button.prop('disabled', true);
        }
    }

    //更新履歴編集modalの編集と取消ボタンをbindする
    function bind_edit_comments_related_btn(){
        //編集ボタン
        $('#EditCommentsModal .edit-comment').on('click', function(){
            var button = $(this);
            var id = button.attr('data-editid');
            var target_textarea = $('#EditCommentsModal [data-commentid="' + id + '"]');
            var cancel_btn = $('.cancel-edit-comment[data-editid="' + id + '"]');
            if(button.attr('data-editing')){
                //編集完了時
                if(target_textarea.val().length > 0){
                    var is_only_blank = (target_textarea.val().trim().length === 0);
                    if(is_only_blank){
                        alert('空白文字のみの登録できません');
                        return false;
                    }
                }else{
                    alert('１文字以上入力して下さい');
                    return false;
                }
                var comments = JSON.parse($('#vul-temp-edited-comments').val());
                for(var i = 0; i < comments.length; i ++){
                    var data = comments[i];
                    if(data['id'] == id){
                        comments[i]['mes'] = target_textarea.val();
                        break;
                    }
                }
                $('#vul-temp-edited-comments').val(JSON.stringify(comments));
                target_textarea.prop('readonly', true);
            }else{
                target_textarea.prop('readonly', false);
            }
            toggle_edit_comment_btn(button);
            toggle_cancel_edit_comment_btn(cancel_btn);
            insert_link_target_elm = null;
        });

        //取消ボタン
        $('#EditCommentsModal .cancel-edit-comment').on('click', function(){
            var button = $(this);
            var id = button.attr('data-editid');
            var target_textarea = $('#EditCommentsModal [data-commentid="' + id + '"]');
            var edit_btn = $('.edit-comment[data-editid="' + id + '"]');
            var comments = JSON.parse($('#vul-temp-edited-comments').val());
            for(var i = 0; i < comments.length; i ++){
                var data = comments[i];
                if(data['id'] == id){
                    target_textarea.val(data['mes']);
                    break;
                }
            }
            target_textarea.prop('readonly', true);
            toggle_edit_comment_btn(edit_btn);
            toggle_cancel_edit_comment_btn(button);
            insert_link_target_elm = null;
        });
         
    }
   
    //更新履歴編集modal
    $('#EditCommentsModal').on('show.bs.modal', function(){
         var comments = $('#vul-comments-data').val();
         $('#vul-temp-edited-comments').val(comments);
         comments = JSON.parse(comments);
         $('#edit-comments-area > *').remove();
         if( Object.keys(comments).length > 0 ){
             var elms = comments.map(function(cmt){
                 //commentid == editidをコメント編集時に使用する
                 var elm = $('<div>').attr('class', 'd-flex edit-comment-item');
                 var textarea = $('<textarea>').attr({
                     'class': 'form-control edit-comment-textarea h-60px',
                     'data-commentid': cmt['id'],
                     'readonly': true,
                 }).val(cmt['mes']);
                 var outer_btn_area = $('<div>').attr('class', 'ml-auto d-table');
                 var wrap = $('<div>').attr('class', 'd-table-cell align-bottom h-60px');
                 var btn_area = $('<div>').attr('class', 'd-flex justify-content-center edit-comment-btn-area');
                 var edit_btn = $('<button>').attr({
                     'type': 'button',
                     'class': 'btn btn-sm btn-edit edit-comment text-nowrap',
                     'data-editid': cmt['id'],
                 }).text('編集');;
                 var cancel_btn = $('<button>').attr({
                     'type': 'button',
                     'class': 'btn btn-secondary cancel-edit-comment text-nowrap',
                     'data-editid': cmt['id'],
                     'disabled': true,
                 }).text('取消');
                 btn_area.append(edit_btn, cancel_btn);
                 wrap.append(btn_area);
                 outer_btn_area.append(wrap);
                 elm.append(textarea, outer_btn_area);
                 return elm;
             });
             $('#edit-comments-area').append(elms);
             bind_edit_comments_related_btn();
             //リンクを編集できるようにする
             $('#edit-comments-area textarea').on('click', function(){
                 if(!$(this).prop('readonly')){    
                     insert_link_target_elm = $(this);
                 }
             });
         }else{
             return false;
         }
    });

    //更新履歴編集modalの「変更」ボタンを押した時
    $('#exec-edit-comments').on('click', function(){
        var edited_comments = $('#vul-temp-edited-comments').val(); 
        $('#vul-comments-data').val(edited_comments);
        edited_comments = JSON.parse(edited_comments);
        $('#vul-comments > *').remove();
        comment_elms = edited_comments.map(function(cmt){
            return $('<li>').attr({
                       'class': 'vul-comment-item',
                       'data-id': cmt['id'],
                   }).text('・ ' + cmt['mes']);
        });
        $('#vul-comments').append(comment_elms);
        $(this).closest('.modal').modal('hide');
        $('#ConfVulModal').modal('show');
    });

    //一括有効/無効変更
    $('#bulk-change-status').on('click', function(){
        $('#pages-offset-for-bulk-change-status').val($('#pages_offset').val());
        $('#pages-perpage-for-bulk-change-status').val($('#pages_per_page').val());
        $('#pages-order-for-bulk-change-status').val($('#pages_order').val());
        $('#pages-filters-for-bulk-change-status').val($('#pages_filters').val());
        var checked = JSON.parse($('#pages_checked').val());
        $('#bulk-change-status-ids').val(JSON.stringify(checked));
        var vul_names = JSON.parse($('#all-vul-names').val());
        $('#BulkStatusBody > * ').remove();
        $('#BulkStatusModal').modal('show');
        checked.forEach(function(id){
            var name = vul_names[id];
            var tr = $('<tr>');
            var td = $('<td>').attr('class', 'text-left').text(name);
            tr.append(td);
            $('#BulkStatusBody').append(tr);
        });   
   
    });

    $('#exec-bulk-change-status').on('click', function(){
        $('#form-bulk-change-status').submit();
    });

    //削除
    function delete_local_vul(id){
        var progress_window = get_progress_bar();
        $('body').append(progress_window);
 
        var path = $('#sidfm_local_vuls_delete_path').val();
        $.post(
            path,
            { 'delete_id': id },
            function(data){
                if( data['err_message'] ){
                    alert(data['err_message']);
                    location.reload();
                }else{
                    update_view(data['host_ids'], [ data['html_id'] ], true);
                }
            }
        );
    }    
    $('.delete-vul[data-deleteid]').on('click', function(){
        var delete_id = $(this).data('deleteid');
        var all_vul_names = JSON.parse($('#all-vul-names').val());
        var path = $('#sidfm_local_vuls_get_issue_related_vul_ids_path').val();
        $.post(path, {'vul_ids': JSON.stringify([ delete_id ])}, function(issue_related_vul_ids){
            if( issue_related_vul_ids.includes(parseInt(delete_id)) ){
                var msg = 'このローカル脆弱性「' + all_vul_names[delete_id] + '」には、関連する脆弱性チケットがあります。' +
                          '\nこの脆弱性を削除すると、関連する脆弱性チケットも削除されます。' +
                          '\n削除せずにこの脆弱性を「無効」にすることで、脆弱性チケットを残したまま、ローカル脆弱性を削除した状態にすることができますので、通常は推奨致しません。' +
                          '\n本当に実行してよろしいですか?';
            }else{
                var msg = '「' + all_vul_names[delete_id] + '」を削除します。よろしいですか?';
            }
            var conf = confirm(msg);
            if( conf ){
                //$('#delete-form-' + delete_id).submit();
                delete_local_vul(delete_id);
            }else{
                return false;
            }
        });
    });

    //一括削除
    function bulk_delete_local_vuls(ids){
        var progress_window = get_progress_bar();
        $('body').append(progress_window);

        var path = $('#sidfm_local_vuls_bulk_delete_path').val();
        $.post(
            path,
            { 'ids': ids },
            function(data){
                if( data['err_message'] ){
                    alert(data['err_message']);
                    location.reload();
                }else{
                    update_view(data['host_ids'], data['html_ids'], true);
                }
            }
        );
    }
    $('#bulk-delete-vuls').on('click', function(){
        var checked = JSON.parse($('#pages_checked').val());
        //$('#bulk-delete-ids').val(JSON.stringify(checked));
        var all_vul_names = JSON.parse($('#all-vul-names').val());
        var vul_names = [];
        var issue_related_vul_names = [];
        var path = $('#sidfm_local_vuls_get_issue_related_vul_ids_path').val();
        $.post(path, {'vul_ids': JSON.stringify(checked)}, function(issue_related_vul_ids){
            checked.forEach(function(id){
                if( issue_related_vul_ids.includes(parseInt(id)) ){
                    issue_related_vul_names.push('「' + all_vul_names[id] + '」');
                }
                vul_names.push('「' + all_vul_names[id] + '」');
            });
            var msg = vul_names.join(', ') + 'を削除します。'
            if( issue_related_vul_names.length > 0 ){
                msg += '\n※' + issue_related_vul_names.join(', ') + 'には、関連する脆弱性チケットがあります。' + 
                       '\n' + (issue_related_vul_names.length == 1 ? 'この' : 'これらの') + 
                       '脆弱性を削除すると、関連する脆弱性チケットも削除されます。' +
                       '\n削除せずに' + (issue_related_vul_names.length == 1 ? 'この' : 'これらの') + 
                       '脆弱性を「無効」にすることで、脆弱性チケットを残したまま、ローカル脆弱性を削除をした状態にすることができますので、通常は推奨致しません。' +
                       '\n本当に実行してよろしいですか?';
            }else{
                msg += 'よろしいですか?';
            }
            var conf = confirm(msg);
            if(conf){
                //$('#form-bulk-delete').submit();
                bulk_delete_local_vuls(JSON.stringify(checked));
            }else{
                return false;
            }
        });
    });

    //エクスポート
    $('#export-local-vuls').on('click', function(){
        var conf = confirm('ファイルをダウンロードします');
        if( !conf ){
            return false;
        }
        var message = '';
        var progress_window = get_progress_bar('get');
        $('body').append(progress_window);
        var export_path = $('#sidfm_local_vuls_export_path').val();
        var checked = JSON.parse($('#pages_checked').val());
        var total_size = 0;
        var executed_size = 0;
        var export_file = $.ajax({
            url: export_path,
            type: 'POST',
            data: { 'checked': JSON.stringify(checked), 'process': 'start_export' },
        }).done(function(res){
            if( res['err'] ){
                alert(res['message'] + '画面をリロードします。' );
                location.reload();
            }else{
                total_size = res['total_size'];
                var progress_export = function(){
                    $.ajax({
                        url: export_path,
                        type: 'POST', 
                        data: { 'process': 'progress_export'}
                    }).done(function(res){
                         if( res['err'] ){
                             alert(res['message'] + '画面をリロードします。' );
                             location.reload();
                         }else if( res['executed_size'] == 0 ){
                             $('#form-export').submit();
                             $('#progress-bar-label').text('ファイル送信中...');
                             var timer = setInterval(function(){
                                 if( $.cookie('export_flg') ){
                                     setTimeout(function(){//probress barのbarが満たされるまで待つ
                                         $.cookie('export_flg',"",{path:"/",expires:-1});
                                         $('#progress-window').remove();
                                     },500);
                                     clearInterval(timer);
                                 }
                             },10);
                         }else{
                             executed_size += res['executed_size'];
                             var percentage = (executed_size / total_size * 100);
                             if( percentage >= 99 && percentage < 100 ){
                                 percentage = 99;
                             }else{
                                 percentage = Math.round(percentage);
                             }
                             $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                             progress_export();
                         }
                    }).fail(function(){
                        alert('ファイルのエクスポートに失敗しました。' ); 
                        location.reload();
                    });
                };
                progress_export();
            }
        }).fail(function(){
            alert('ファイルのエクスポートに失敗しました。' );
            location.reload();
        });
    });

    //インポート
    $('#submit-import-file').on('click', function(){
        var import_path = $('#sidfm_local_vuls_import_path').val();
        var progress_import_path = $('#sidfm_local_vuls_progress_import_path').val();
        var read_file_path = $('#sidfm_local_vuls_read_import_file_path').val();
        var fd = new FormData();
        var target_elm = $('#import-file');
        var file = target_elm.get(0).files[0];
        if( !file ){
            alert('ファイルを選択して下さい');
            return false;
        }
        var file_name = target_elm.attr('name');
        fd.append(file_name, file)
        var progress_window = get_progress_bar();
        $('body').append(progress_window);
        var percentage = 0;
        var total_size = 0;
        var executed_size = 0;
        var is_err = false;

        var progress_import = function(){
            $.ajax({
                url: progress_import_path,
                type: 'GET',
            }).done(function(res){
                if( res['err'] ){
                   alert('ファイルのインポートに失敗しました。画面をリロードします。');
                   location.reload();
                }else{
                    if( res['executed_size'] > 0 ){
                        executed_size += res['executed_size'];
                        var percentage = (executed_size / total_size * 100);
                        if( percentage >= 99 && percentage < 100 ){
                            percentage = 99;
                        }else{
                            percentage = Math.round(percentage);
                        }
                        $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                        progress_import();
                    }else{
                        setTimeout(function(){//probress barのbarが満たされるまで待つ
                            location.href = import_path;
                        }, 500);
                    }
                }
            }).fail(function(){
                alert('ファイルのインポートに失敗しました。画面をリロードします。');
                location.reload();
            });
        };

        //ファイル読み込み
        $.ajax({
           url: read_file_path,
           type: 'POST',
           data: fd,
           processData: false,
           contentType: false
        }).done(function(res){
            if( res['err'] ){
                alert('ファイルのインポートに失敗しました。画面をリロードします。');
                location.reload();
            }else{
                if( res['total_size'] ){
                    total_size = res['total_size'];
                }
                progress_import();
            }
        }).fail(function(){
            alert('ファイルのインポートに失敗しました。画面をリロードします。');
            location.reload();
        });
     
    });
});
 
